SystemOrganization addCategory: #'NativeBoost-Examples'!

!ByteString methodsFor: '*NativeBoost-Examples' stamp: 'IgorStasenko 11/24/2012 15:52'!
nbBeginsWithByteString: prefix
"an assembler implementation of #beginsWith: ,
note, works only for byte strings "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCallout function: #( oop (oop self, oop prefix) ) emit: [:gen :proxy :asm |
		| string sz1 prefixStr sz2 returnFalse done |
		
		string := gen reserveTemp.
		sz1 := gen reserveTemp.
		prefixStr := gen reserveTemp.
		sz2 := gen reserveTemp.
		returnFalse := asm uniqueLabelName: 'returnFalse'.
		done := asm uniqueLabelName: 'done'.
		
		asm mov: asm ESP ptr to: asm EAX  "self ".
		proxy varBytesFirstFieldOf:  asm EAX.
		asm mov: asm EAX to: string.

		asm pop: asm EAX  "self ".
		proxy byteSizeOf: asm EAX. 
		asm mov: asm EAX to: sz1.


		asm mov: asm ESP ptr to: asm EAX  "self ".
		proxy varBytesFirstFieldOf: asm EAX.
		asm mov: asm EAX to: prefixStr.

		asm pop: asm EAX  "self ".
		proxy byteSizeOf: asm EAX. 
		asm mov: asm EAX to: sz2.
		
		asm 
			mov: sz1 to: asm EAX;
			cmp: asm EAX with: sz2;
			jl: returnFalse.

		asm 
			mov: string to: asm ESI;
			mov: prefixStr to: asm EDI;
			mov: sz2 to: asm ECX;
			cld;
			repe; cmpsb;
			
			cmp: asm ECX with: 0;
			jnz: returnFalse.

		proxy trueObject.
		asm jmp: done.

		asm label: returnFalse.
		proxy falseObject.
		asm label: done
	] 
! !

NBExternalType subclass: #NBUTF8StringExample
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Examples'!

!NBUTF8StringExample commentStamp: 'IgorStasenko 8/8/2011 17:29' prior: 0!
This is an example of defining custom type.
This type accepts a string(s) and converts them into utf-8 representation on stack on the fly and then pushes the pointer to converted string to callee.



UTF8TextConverter new convertFromSystemString: (
NBBasicExamples new encodeToUTF8: 'owehjfopeh fr' asWideString)!

!NBUTF8StringExample methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 7/23/2012 13:29'!
prepareArgumentUsing: gen

	"prepare the ByteString argument.
	Allocate a space for string on stack, then copy string contents there
	and add terminating null character "
	
	| asm stringOop len loop done donePreparing notNil 
	 moreThanOne moreThanTwo moreThanThree typeCheck |
	
	asm := gen asm.
	
	typeCheck := asm uniqueLabelName: 'ok'.
	loop := asm uniqueLabelName: 'loop'.
	done := asm uniqueLabelName: 'done'.
	notNil  := asm uniqueLabelName: 'notNil'.
	donePreparing := asm uniqueLabelName: 'donePreparing'.
	moreThanOne := asm uniqueLabelName: 'moreThanOne'.  
	moreThanTwo := asm uniqueLabelName: 'moreThanTwo'.  
	moreThanThree := asm uniqueLabelName: 'moreThanThree'.  
	    
	loader emitLoad: gen.

	"reserve after emitting load, otherwise, if proxy using stackpointer temp, it will be clobbered"
	address := gen reserveTemp.  
	stringOop := gen reserveTemp.
	len := gen reserveTemp.

	asm mov: EAX to: stringOop.
	
	gen optStringOrNull ifTrue: [
		"allow passing nil as string, effectively will push null pointer as argument"
		gen proxy nilObject.
		asm 
			cmp: EAX with: stringOop;
			jne: notNil;
			mov: 0 to: address;  "null pointer"
			jmp: donePreparing.
	].
	asm label: notNil.
	gen proxy isWords: stringOop.
	asm or: EAX with: EAX.
	asm jne: typeCheck.
	gen failWithMessage: 'WideString instance expected'.
	asm label: typeCheck.	
	gen proxy slotSizeOf: stringOop.
	asm mov: EAX to: len.

	"len*4 +1 - the total number of bytes to reserve on stack"
	asm 
		shl: EAX with: 2;
		inc: EAX.
	gen reserveStackBytes: EAX andStoreAddrTo: address.

	gen proxy firstIndexableField: stringOop.

	asm decorateWith: ' copy string contents to the stack ' during: [
	asm 
		push: ESI;
		push: EDI;
		mov: EAX to: ESI;
		mov: address to: EDI;
		mov: len to: ECX;

	label: loop;
		dec: ECX;
		jl: done;
		
		"load the unicode value"
		mov: ESI ptr to: EAX;
		
		cmp: EAX with: 16r7F;
		jg: moreThanOne;
	"one byte"
		mov: AL to: EDI ptr;
		inc: EDI;
		add: ESI with: 4;
		jmp: loop;
	label: moreThanOne;
		cmp: EAX with: 16r7FF;
	 	jg: moreThanTwo;
	"two bytes"
		mov: EAX to: EDX;
		shr: EDX with: 6;
		or: DL with: 16rC0 asUImm;
		mov: DL to: EDI ptr;
		inc: EDI;
		and: AL with: 2r111111;
		or: AL with: 16r80 asUImm;
		mov: AL to: EDI ptr;
		inc: EDI;
		add: ESI with: 4;
		jmp: loop;
	label: moreThanTwo;
		cmp: EAX with: 16rFFFF;
	 	jg: moreThanThree;
	"three bytes"	
		mov: EAX to: EDX;
		shr: EDX with: 12;
		or: DL with: 2r11100000 asUImm;
		mov: DL to: EDI ptr;
		inc: EDI;

		mov: EAX to: EDX;
		shr: EDX with: 6;
		and: DL with: 2r111111;
		or: DL with: 16r80 asUImm;
		mov: DL to: EDI ptr;
		inc: EDI;

		and: AL with: 2r111111;
		or: AL with: 16r80 asUImm;
		mov: AL to: EDI ptr;
		inc: EDI;
		add: ESI with: 4;
		jmp: loop;
		
	label: moreThanThree;
		cmp: EAX with: 16r1FFFFF;
		jg: gen failedLabel; "no more than 4 bytes!!"
	"4 bytes"
		mov: EAX to: EDX;
		shr: EDX with: 18;
		or: DL with: 2r11110000 asUImm;
		mov: DL to: EDI ptr;
		inc: EDI;

		mov: EAX to: EDX;
		shr: EDX with: 12;
		and: DL with: 2r111111;
		or: DL with: 16r80 asUImm;
		mov: DL to: EDI ptr;
		inc: EDI;

		mov: EAX to: EDX;
		shr: EDX with: 6;
		and: DL with: 2r111111;
		or: DL with: 16r80 asUImm;
		mov: DL to: EDI ptr;
		inc: EDI;

		and: AL with: 2r111111;
		or: AL with: 16r80 asUImm;
		mov: AL to: EDI ptr;
		inc: EDI;
		add: ESI with: 4;
		jmp: loop;
		
	label: done;
		mov: 0 to: EDI ptr8;  "store null-terminating character"
		pop: EDI;
		pop: ESI.
	].
	gen releaseTemps: 2.  "keep the address reserved, otherwise it will be clobbered"
	asm label: donePreparing! !

!NBUTF8StringExample methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/6/2011 16:04'!
pushAsValue: gen

	gen asm push: address.

! !

Object subclass: #NBBasicExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Examples'!

!NBBasicExamples commentStamp: '<historical>' prior: 0!
I am a collection on examples on how to use the NativeBoost infrastructure. 
Check my class-side methods for more details.!

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:04'!
failIfNegative: anInteger
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( void ( int anInteger ) )  
		emit: [:gen :proxy :asm |
			"aNumber -> EAX"
			asm pop: asm EAX.
			"check if the index in EAX is negative"
			asm test: asm EAX with: asm EAX.
			"if not signed (AKA positive jump to success)"
			asm jns: 'success'.
			gen failWithMessage: 'A negative number is forbidden!!'.
			asm label: 'success'.
		]! !

!NBBasicExamples class methodsFor: 'basic-external-function' stamp: 'ThierryGoubier 7/2/2013 15:38'!
nbAccess: str mode: mode
	"
	This is a basic example for making an external call. 
	This method calls a Standard C library euidaccess() function
	
	F_OK=0, R_OK=4, W_OK=2, X_OK=1
	
	Safer to use euidaccess instead of access.
"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: #errorCode>
	^ self nbCall: #(#int #euidaccess #(#String #str #, #int #mode)) module: NativeBoost CLibrary! !

!NBBasicExamples class methodsFor: 'basic-external-function' stamp: 'IgorStasenko 8/24/2012 15:13'!
nbGetEnv: str
"
	This is a basic example for making an external call. 
	This method calls a Standard C library getenv() function
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
	 ^ self nbCall: #( String getenv (String str) ) module: NativeBoost CLibrary! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:05'!
primitiveFail
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			"Fail the native code"
			proxy primitiveFail.
		].! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:06'!
primitiveFailWithMessage
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			"Fail the native code"
			gen failWithMessage: 'here is a message you wanna show to users when you fail a primitive'
		].! !

!NBBasicExamples class methodsFor: 'basc-types' stamp: 'IgorStasenko 11/23/2012 14:06'!
returnAddressOf: anObject
	"Yes, here we demonstrating that we can obtain a pointer (address) of object in memory.
	But in fact it has no any practical use, because at any moment once you return from the method,
	a GC may be triggered and given object can be relocated into different memory region,
	rendering an obtained address invalid"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( int ( oop anObject ) )  
		emit: [:gen :proxy :asm |
			asm pop: asm EAX.
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:07'!
returnArrayClass
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			"Access an internal data structure via the interpreter proxy"
			proxy classArray.
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:07'!
returnAsBit: aBoolean
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( int ( oop aBoolean ) )  
		emit: [:gen :proxy :asm |
			" aBoolean -> EAX "
			asm pop: asm EAX.
			"^ EAX = true ifTrue: [ 1 ] ifFalse: [ 0 ] "
			proxy booleanValueOf: asm EAX.
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:08'!
returnClassOf: anObject
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( oop anObject ) )  
		emit: [:gen :proxy :asm |
			" anObject -> EAX "
			asm pop: asm EAX.
			"^ anObject class "
			proxy fetchClassOf: asm EAX.
		]! !

!NBBasicExamples class methodsFor: 'basc-types' stamp: 'CamilloBruni 7/16/2012 10:33'!
returnFloat! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:11'!
returnInstVar: aNumber from: anObject
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( int aNumber, oop anObject ) )  
		emit: [:gen :proxy :asm |
			"aNumber -> EAX"
			asm pop: asm EAX.
			"EAX = aNumebr-1"
			asm sub: asm EAX with: 1.
			"if signed (AKA negative jump to failure)"
			asm js: 'failure'.
		
			"anObject -> EDX"
			asm pop: asm EDX.
			"EAX = anObject instVarAt: aNumber"
			proxy fetchPointer: asm EAX ofObject: asm EDX.
			asm leave; ret.
				
			asm label: 'failure'.
			proxy primitiveFail.
		]! !

!NBBasicExamples class methodsFor: 'basc-types' stamp: 'IgorStasenko 11/23/2012 14:11'!
returnInteger
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( int ( void) )  
		emit: [:gen :proxy :asm |
			asm mov: 123456789 to: asm EAX
		]! !

!NBBasicExamples class methodsFor: 'basc-types' stamp: 'IgorStasenko 11/23/2012 14:11'!
returnInteger: a minus: b
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( int ( int a,  int b) )  
		emit: [:gen :proxy :asm |
			" a "
			asm pop: asm EAX.
			" b "
			asm pop: asm EDX.
			"result := a - b"
			asm sub: asm EAX with: asm EDX
		]! !

!NBBasicExamples class methodsFor: 'basc-types' stamp: 'IgorStasenko 11/23/2012 14:12'!
returnIntegerDirectOOP
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

"here, since we put a return type 'oop', this means that NB FFI won't perform any conversion
of returned value, therefore a native code must take care by itself for returning a valid oop"
	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			asm mov: (123456789 << 1) + 1 to: asm EAX
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:12'!
returnMethodLiteral
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			"store this method in EAX"
			proxy primitiveMethod.
			"the current method is in EAX
				EAX literalAt: 0 "
			proxy literal: 0 ofMethod: asm EAX.
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:12'!
returnNewArraySize3
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void ))  
		emit: [:gen :proxy :asm |
			"Array -> EAX"
			proxy classArray.
			"Array new: 3 (Array oop is stored in EAX)"
			proxy instantiateClass: asm EAX indexableSize: 3
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:13'!
returnNil
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void ) )  
		emit: [:gen :proxy :asm |
			"nilObject -> EAX"
			proxy nilObject.
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:13'!
returnSelf
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			"this is equivalent to: 
				proxy receiverInto: asm EAX."
			proxy receiver.
		]! !

!NBBasicExamples class methodsFor: 'basic-interpreter-proxy-interaction' stamp: 'IgorStasenko 11/23/2012 14:13'!
returnSpecialObjectsArray
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		function: #( oop ( void) )  
		emit: [:gen :proxy :asm |
			"store the special objects array into EAX"
			proxy specialObjectsArray.
		]! !

!NBBasicExamples class methodsFor: 'basic-float-operations' stamp: 'IgorStasenko 11/23/2012 14:13'!
swapDoubFirst: r1 withSecond: r2
 
    <primitive: #primitiveNativeCall module: #NativeBoostPlugin>

    ^ self nbCallout
		function: #( double ( double r1, double r2 ))
	    emit: [:gen :proxy :asm |
			"store r1 and r2 into the FPU stack"
	       asm fld: asm ESP ptr64.
	       asm fld: asm ESP ptr64 + 8.
			"swap the two topmost FPU stack elements"
			asm fxch: asm ST1.
 	   ]! !

!NBBasicExamples methodsFor: 'custom type' stamp: 'IgorStasenko 11/23/2012 14:15'!
encodeToUTF8: aWideString

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^
		self nbCallout 
			function: #(String (NBUTF8StringExample aWideString)) 
			emit: [:gen :proxy :asm |
				asm pop: asm EAX
			] ! !

!NBBasicExamples methodsFor: 'double type' stamp: 'IgorStasenko 11/23/2012 14:16'!
externalAddressValue: externalAddress
	"
	NBBasicExamples new externalAddressValue: (NBExternalAddress value: 10)

	Error message is in: 
	#verifyClassOf:is:generator:

	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout  
		 
		function: #( ulong ( NBExternalAddress  externalAddress) )  
		emit: [:gen :proxy :asm |
			asm pop: asm EAX
		]! !

!NBBasicExamples methodsFor: 'object format' stamp: 'Igor.Stasenko 12/9/2010 14:29'!
getObjectHeader: anObject
	"Answer the word, representing an object header. See Object>>nbOopHeader for implementation.
	This method provided only for educational purposes"
	
	^ anObject nbOopHeader! !

!NBBasicExamples methodsFor: 'double type' stamp: 'IgorStasenko 11/23/2012 14:23'!
readDoubleFrom: address
	" This method loads the double from given external address.
	an address can be an instance of NBExternalAddress, or
	simple ByteArray with at least 8 bytes long, which holds a double floating value"
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin' error: errorCode>

	"We are using a pseudo-function prototype and supplying own assembler code,
	instead of making a call to external function.
	In given example, an address argument , after coercion is pushed on stack. "
	
	^ self nbCallout

		"An additional options may affect the code generation. If options are omitted, then code generator will use defaults
			(see NBFFICallout class>>defaultOptions)"
		options: #( 
			"do not accept nil as a pointer argument. 
			This means that passing nil as address will cause a primitive failure."
		- optCoerceNilToNull  
		
			" accept a byte array as pointer. In our case, address to a first byte in byte array will be pushed on stack"
		+ optAllowByteArraysPtr
		
			" accept an instance of NBExternalAddress when coercing pointer arguments.
			In our case, this method can accept NBExternalAddres in its address argument"
		+ optAllowExternalAddressPtr
		
		);

		cdecl;  "Use cdecl C calling convention. This can be actually omitted, because it is default convention used by code generator. "		
				
		function: #( double ( void * address) )  
		" A pseudo-function takes 1 argument, and returns double value.
		  Under cdecl call convention, all floating point return types is returned in fp(0) CPU register"
		
		emit: [:gen |  | asm |
			asm := gen asm.

			"Here , we expecting that an address value is already pushed on stack"
			
			asm 
				pop: asm EAX;  "load an address value into EAX register by popping a stack"
				fld: (asm EAX ptr64). "load a floating point value from memory, at base address, held in EAX register into fp(0) register,
				we are using #ptr64, to indicate that memory operand size is 64bits long"
			
			" return value set, we are done. A code generator will take care for emitting code, which converts
			a double floating point value into smalltalk object. "
		]
! !

!NBBasicExamples methodsFor: 'double type' stamp: 'IgorStasenko 11/23/2012 14:23'!
storeDouble: aDouble at: address
	" This method stores a double floating point value at given memory address.
	an address can be an instance of NBExternalAddress, or
	simple ByteArray with at least 8 bytes long, which will hold a 64bit floating-point value"
	
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin' error: errorCode>

	"We are using a pseudo-function prototype and supplying own assembler code,
	instead of making a call to external function.
	An address and aDouble arguments are pushed on stack after coercion. "
	
	^ self nbCallout 
		"An additional options may affect the code generation. If options are omitted, then code generator will use defaults
		(see NBFFICallout class>>defaultOptions)"

		 options: #( 
			"do not accept nil as a pointer arument. 
			This means that passing nil as address will cause a primitive failure."
		- optCoerceNilToNull  
		
			" accept a byte array as pointer. In our case, address to a first byte in byte array will be pushed on stack"
		+ optAllowByteArraysPtr
		
			" accept an instance of NBExternalAddress when coercing pointer arguments.
			In our case, this method can accept NBExternalAddres in its address argument"
		+ optAllowExternalAddressPtr
		
		);
		function: #( void (void * address, double aDouble) )  
		" A pseudo-function takes 2 arguments, and having no return value. In this case, method will always answer nil object.
		  Under cdecl calling convention, arguments are pushed on stack in reverse order,
		  so, first pushed aDouble , then address"
		
		emit: [:gen |  | asm |
			asm := gen asm.

			"Here , we expecting that an address value is on top of the stack"
			asm 
				pop: EDX;  "load an address value into EDX register by popping it from a stack"
			
				"now copy the floating point value (which is 8-bytes long) to the given address"
				mov: ESP ptr to: EAX;
				mov: EAX to: EDX ptr;  " store first 32bit part of 64bit double value"
			
				mov: ESP ptr + 4 to: EAX;
				mov: EAX to: EDX ptr + 4.  " store second 32bit part of 64bit double value"
			
		]
	
	! !

!NBBasicExamples methodsFor: 'double type' stamp: 'Igor.Stasenko 9/23/2010 04:53'!
writeAndReadDoubles

	| d bytes result |
	
	d := 1.5 .
	
	bytes := ByteArray new: 8.
	
	self storeDouble: d at: bytes.
	
	result := self readDoubleFrom: bytes.
	
	self assert: (result = d ).! !

Object subclass: #NBCPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Examples'!

NBCPrinter class
	instanceVariableNames: 'printFormat'!

NBCPrinter class
	instanceVariableNames: 'printFormat'!

!NBCPrinter class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/27/2010 01:46'!
initialize
	" self initialize "
	printFormat := '%s'.! !

!NBCPrinter class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:20'!
printf: aString

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #( void printf (String printFormat, String aString) )
		module: NativeBoost CLibrary! !

!Object methodsFor: '*NativeBoost-Examples' stamp: 'IgorStasenko 11/23/2012 14:02'!
nbOopHeader
" This method provided only for educational purposes. 
 Do not rely on it, if you wanna keep your code portable among various object memory formats "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	" simply return an object header word in a form which it is "
	
	^ self nbCallout   
		function:  #( uint (oop self) )
		emit: [:gen :proxy :asm |  
			asm 
				pop: asm EAX;
				push: asm EAX.
				
			proxy isIntegerObject: asm EAX.
			asm or: asm EAX with: asm EAX;
				jne: #notOop;
				pop: asm EAX;
				mov: asm EAX ptr to: asm EAX; "load the header"
				jmp: #exitt;
				label: #notOop;
				mov: 0 to: asm EAX;
			label: #exitt
		].! !

!WideString methodsFor: '*NativeBoost-Examples' stamp: 'Igor.Stasenko 5/15/2010 00:31'!
nbHash

	^ self nbStringHash: ByteString identityHash! !

!WideString methodsFor: '*NativeBoost-Examples' stamp: 'IgorStasenko 11/23/2012 18:02'!
nbStringHash: speciesHash

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		function: #(ulong (oop self , ulong speciesHash)) emit: [:gen |
		| asm proxy rcvr cnt EAX EDX ECX ESI EBX |
		asm := gen asm.
		EAX := asm EAX. EDX := asm EDX. ECX := asm ECX. 
		ESI := asm ESI. EBX := asm EBX.
		
		proxy := gen proxy.
		rcvr := gen reserveTemp.
		cnt := gen reserveTemp.
		
		asm pop: rcvr.
		proxy stSizeOf: rcvr.
		asm mov: EAX to: cnt.  "size"
		proxy firstIndexableField: rcvr.
		asm 
			pop: EDX; "speciesHash"
			push: EBX;
			push: ESI;
			mov: cnt to: ECX;
		label: #loop;
			and: EDX with: 16rFFFFFFF;
			dec: ECX;
			jl: #wedone;
			add: EDX with: EAX ptr; "hash := hash + (aString at: pos) asInteger."
			mov: EDX to: EBX;
			and: EBX with: 16r3FFF;  "low := hash bitAnd: 16383."
			mov: EBX to: ESI;
			imul: ESI with: 16r260D;  " 16r260D * low "
			shr: EDX with: 14; 
			imul: EDX with: 16r260D; "16r260D * (hash bitShift: -14)"
			imul: EBX with: 16r0065; " (16r0065 * low) "
			add: EDX with: EBX;
			and: EDX with: 16383;
			shl: EDX with: 14;   " (16r260D * (hash bitShift: -14) + (16r0065 * low) bitAnd: 16383) * 16384 "
			add: EDX with: ESI;

			add: EAX with: 4;
			jmp: #loop;
		label: #wedone;
			pop: ESI;
			pop: EBX;
			mov: asm EDX to: asm EAX.
			
	].
	
! !
NBCPrinter initialize!
